<template>
  <AbsoluteLayout width="100%" heigh=100% class="abslay">
      <Mapbox
        v-if="events"
        width="100%" height="100%"
        accessToken="pk.eyJ1IjoienNsdXNueXMiLCJhIjoiY2l3bWk2MWxnMDAwajJ2cDdraGxoZGFiMCJ9.T_pCtda9Twn-oCsNF7Nrjw"
        hideCompass="false"
        latitude="55.6931" 
        longitude="21.1496"
        zoomLevel="12"
        showUserLocation="true"
        disableZoom="false"
        disableRotation="false"
        disableScroll="false"
        disableTilt="false"
        @mapReady="onMapReady($event)"
        ref="mapRef"
        />
        <!-- mapStyle="mapbox://styles/zslusnys/cjmz7ot7gb8pa2spdionmzl9n" -->

      <!-- <SearchBar @centerCoordinates="changeMapCenter" :visible="isSearching"></SearchBar> -->
      <FabMenu @centerUserLocation="navigateToUserLocation" @toggleSearch="toggleSearch" @toggleAddEvent="toggleAddEvent" ></FabMenu>
      <FlexboxLayout width="100%" height="100%" justifyContent="center" alignItems="center">
          <StackLayout id="background" :class="{secondary: isSearching}">
          </StackLayout>
      </FlexboxLayout>
      <FlexboxLayout flexDirection="column" height="100%" width="100%" id="app">
        <StackLayout class="home-panel" flexGrow="7" id="view">
          <Searching @toggleSearch="toggleSearch" v-if="isSearching" class="searching" />
          
        </StackLayout>
      </FlexboxLayout>

      <StackLayout v-if="showAddEvent" class="create-event-layout" @tap="setCenter" >
        <Label text="Create an event here" tap="" />
      </StackLayout>
      <Label v-if="showAddEvent" text="|" class="absolute-location-pin" marginTop="42%" marginLeft="49%" @tap="setCenter" />
      
      
      
  </AbsoluteLayout>
</template>

<script>

  import FabMenu from '@/components/FabMenu'
  import SearchBar from '@/components/SearchBar'
  import Searching from '@/components/Searching'
  import ViewEventDetails from  '@/components/ViewEventDetails'
  import { get, isEmpty } from 'lodash'
  import { mapGetters } from 'vuex'
  import Create from './Create'

  export default {
    components: { FabMenu, SearchBar, Searching },
    async created() {
      // EventBus.$on("committed-events", eventsList =>{
      //   eventsList.forEach(e => this.addMarker(e))
      // })
      // EventBus.$on("deleteEventMarkers", eventsIdsList => {
      //   console.log(eventsIdsList);
      //   this.removeMarkers(eventsIdsList);
      // });
      console.log('Component created: MapboxComponent');
      await this.$store.dispatch('loadEvents')

    },
    name: "MapboxComponent",
    computed: {
      ...mapGetters({ 
        user: "getUser", 
      }),
      mapboxToken() {
        return this.$mapboxAccessToken
      },
      events() {
        let eventsDict = this.$store.state.core.events
        if (!isEmpty(this.map)) {
          Object.keys(eventsDict).filter(eventId => {
            if (get(eventsDict[eventId].deleted)) {
              return
            }
            if (!this.loadedEvents.includes(eventId)) {
              this.loadedEvents.push(eventId)
              let event = eventsDict[eventId]
              this.addMarker(event)
            }
          })
        }
        return this.$store.state.core.events
      }
    },
    data: () => ({
      fabActive: false,
      map: {},
      loadedEvents: [],
      loading: true,
      isSearching: false,
      showAddEvent: false,
    }),
    methods: {
      toggleSearch() {
        this.isSearching = !this.isSearching
        this.showAddEvent = false
      },
      toggleAddEvent() {
        this.showAddEvent = !this.showAddEvent
      },
      async addMarker(event) {
        if (!this.map) {
          throw new Error('There\'s no map to add a marker to')
        }
        this.map.addMarkers([
          {
            id: event.id,
            lat: event.lat,
            lng: event.lng,
            title: event.name,
            subtitle: event.description,
            selected: false, // makes the callout show immediately when the marker is added (note: only 1 marker can be selected at a time)
            userId: event.user,
            onCalloutTap: () =>
              this.$navigateTo(ViewEventDetails, {
                props: {
                  eventId: event.id
                }
              })
          }
        ]);
        
      },
      async setCenter() {
        const center = await this.map.getCenter()
        console.log('center :', center);
        await this.$navigateTo(Create, {
          props: {
            lat: center.lat,
            lng: center.lng,
            userId: this.user.uid
          },
          transition: {
            name: "fade",
            duration: 2000
          },
          transitionAndroid: {
            name: "fade"
          }
        })
      },
      fabTapped() {
        this.fabActive = !this.fabActive
      },

      changeMapCenter(center) {
        let map = this.$refs.mapRef.nativeView;
        map.setCenter({
          lat: center[1],
          lng: center[0],
          animated: false
        })
      },
      async onMapReady(args) {
        this.map = args.map;
        console.log('map is ready');
        // let initialEvents = this.events.map(async (ed) => {
        //   // ed - event details
        //   let event = {
        //     ...ed,
        //     title: ed.name,
        //     subtitle: ed.description,
        //     selected: false,
        //     onCalloutTap: async () =>
        //       this.$navigateTo(ViewEventDetails, {
        //         props: { eventId: ed.id }
        //       })
        //   };
        //   return event;
        // });
        // this.map.addMarkers(initialEvents);

        // map.setOnMapLongClickListener(point => {
        //   this.$navigateTo(Create, {
        //     props: {
        //       mapRef: map,
        //       lat: point.lat,
        //       lng: point.lng,
        //       userId: this.user.id
        //     },
        //     transition: {
        //       name: "fade",
        //       duration: 2000
        //     },
        //     transitionAndroid: {
        //       name: "fade"
        //     }
        //   })
        // })
        
        await this.navigateToUserLocation()
      },
      async navigateToUserLocation() {
        const userLocation = await this.map.getUserLocation() 
        this.map.setCenter({lat: userLocation.location.lat, lng: userLocation.location.lng})
      }
    },
  }
</script>

<style scoped>
.searching {
  z-index: 100000;
}
#background {
  width: 100;
  height: 100;
  border-radius: 100%;
}

#background.secondary {
  background: linear-gradient(-45deg, #53ba82, #52a578);
  animation-name: circle;
  animation-duration: 1s;
  animation-fill-mode: forwards;
}

@keyframes circle {
    from {
        transform: scale(0)
    }

    to {
        transform: scale(10)
    }
}
.create-event-layout {
  width: auto;
  height: 34;
  background-color: rgb(28, 156, 225);
  border-radius: 18;
  vertical-align: center;
  margin-top: 39%;
  margin-left: 32%;
  padding: 0, 15em;
  /* When moving */
  /* width: 34;
  height: 34;
  background-color: orangered;
  border-radius: 28;
  vertical-align: center;
  margin-top: 40%;
  margin-left: 46% */
}
/* .fab-button {
  margin-top: 87%;
  margin-left: 80%;
} */
.absolute-location-pin {
  color: #000000;
  font-size: 40em;
}
.create-btn {
  border-radius: 30;
}
</style>